diff --git a/.gitignore b/.gitignore
index 0f31820627e20f4affc985cb72ea4bd5448d440e..1ba75facf370eea54a5d36ee90146cdae025dafb 100644
--- a/.gitignore
+++ b/.gitignore
@@ -37,4 +37,4 @@ doxygen.log
 out/
 *.orig
 tests/CI/output
-
+.develvars
diff --git a/build_tools/make_version b/build_tools/make_version
index aefe6b1c83f6cede04ef86edaeb1698913f8887b..9dca4bd9dce347b597b5300c7dd64361adcc18da 100755
--- a/build_tools/make_version
+++ b/build_tools/make_version
@@ -3,11 +3,13 @@
 AWK=${AWK:-awk}
 GIT=${GIT:-git}
 GREP=${GREP:-grep}
+SED=${SED:-sed}
+
 
 if [ -f ${1}/.version ]; then
     cat ${1}/.version
 elif [ -d ${1}/.svn ]; then
-    PARTS=`LANG=C svn info ${1} | ${GREP} URL | ${AWK} '{print $2;}' | sed -e 's:^.*/svn/asterisk/::' | sed -e 's:/: :g'`
+    PARTS=`LANG=C svn info ${1} | ${GREP} URL | ${AWK} '{print $2;}' | ${SED} -e 's:^.*/svn/asterisk/::' | ${SED} -e 's:/: :g'`
     BRANCH=0
     TEAM=0
     TAG=0
@@ -93,16 +95,33 @@ elif [ -d ${1}/.git ]; then
         echo "UNKNOWN__and_probably_unsupported"
         exit 1
     fi
-	cd ${1}
+    cd ${1}
 
     # If the first log commit messages indicates that this is checked into
     # subversion, we'll just use the SVN- form of the revision.
     MODIFIED=""
-    SVN_REV=`${GIT} log --pretty=full -1 | sed -n '/git-svn-id:/ s/.*\@\([^ ]*\) .*/\1/p'`
+    SVN_REV=`${GIT} log --pretty=full -1 | ${SED} -n '/git-svn-id:/ s/.*\@\([^ ]*\) .*/\1/p'`
     if [ -z "$SVN_REV" ]; then
-        MAINLINE_BRANCH=$(${GIT} config -f .gitreview --get gerrit.basebranch)
-        if [ "x${MAINLINE_BRANCH}" = "x" ] ; then
-            MAINLINE_BRANCH=$(${GIT} config -f .gitreview --get gerrit.defaultbranch)
+        # If MAINLINE_BRANCH is already set in the environment, use it.
+        if [ -z "${MAINLINE_BRANCH}" ] ; then
+            # Try to retrieve MAINLINE_BRANCH from a local .develvars file first.
+            # .develvars is keyed by the branch name so we need to get that first.
+            BRANCH=$(${GIT} symbolic-ref --short HEAD)
+            if [ -f .develvars ] ; then
+                MAINLINE_BRANCH=$(${GIT} config -f .develvars --get branch.${BRANCH}.mainline-branch)
+            fi
+
+            # If we didn't find it, see if this is a well-known development branch.
+            # development/<mainline_branch>/<branchname> or
+            # devel/<mainline_branch>/<branchname>
+            if [ "x${MAINLINE_BRANCH}" = "x" ] ; then
+                MAINLINE_BRANCH=$(echo "${BRANCH}" | ${SED} -n -r -e "s@devel(opment)?/([0-9]+)/.+@\2@p")
+            fi
+
+            # If we didn't find it, get it from .gitreview defaultbranch.
+            if [ "x${MAINLINE_BRANCH}" = "x" ] ; then
+                MAINLINE_BRANCH=$(${GIT} config -f .gitreview --get gerrit.defaultbranch)
+            fi
         fi
 
         VERSION=`${GIT} describe --long --always --tags --dirty=M 2> /dev/null`
@@ -116,7 +135,7 @@ elif [ -d ${1}/.git ]; then
         fi
         echo GIT-${MAINLINE_BRANCH}-${VERSION}
     else
-        PARTS=`LANG=C ${GIT} log --pretty=full | ${GREP} -F "git-svn-id:" | head -1 | ${AWK} '{print $2;}' | sed -e s:^.*/svn/$2/:: | sed -e 's:/: :g' | sed -e 's/@.*$//g'`
+        PARTS=`LANG=C ${GIT} log --pretty=full | ${GREP} -F "git-svn-id:" | head -1 | ${AWK} '{print $2;}' | ${SED} -e s:^.*/svn/$2/:: | ${SED} -e 's:/: :g' | ${SED} -e 's/@.*$//g'`
         BRANCH=0
         TEAM=0
         TAG=0
diff --git a/tests/CI/buildAsterisk.sh b/tests/CI/buildAsterisk.sh
index 52f762e9a5c8c7ebfcca5c5aa10a728c76ccc7c3..71cfcc69151d27528f3267062c8e3688b0231781 100755
--- a/tests/CI/buildAsterisk.sh
+++ b/tests/CI/buildAsterisk.sh
@@ -17,6 +17,10 @@ if [ -z $BRANCH_NAME ]; then
 	BRANCH_NAME=$(git config -f .gitreview --get gerrit.defaultbranch)
 fi
 
+if [[ "$BRANCH_NAME" =~ devel(opment)?/([0-9]+)/.+ ]] ; then
+	export MAINLINE_BRANCH="${BASH_REMATCH[2]}"
+fi
+
 gen_cats() {
 	set +x
 	action=$1
@@ -91,6 +95,11 @@ MAKE=`which make`
 PKGCONFIG=`which pkg-config`
 _libdir=`${CIDIR}/findLibdir.sh`
 
+_version=$(./build_tools/make_version .)
+for var in BRANCH_NAME MAINLINE_BRANCH OUTPUT_DIR CACHE_DIR CCACHE_DISABLE CCACHE_DIR _libdir _version ; do
+	declare -p $var || :
+done
+
 common_config_args="--prefix=/usr ${_libdir:+--libdir=${_libdir}} --sysconfdir=/etc --with-pjproject-bundled"
 $PKGCONFIG 'jansson >= 2.11' || common_config_args+=" --with-jansson-bundled"
 common_config_args+=" ${CACHE_DIR:+--with-sounds-cache=${CACHE_DIR}/sounds --with-externals-cache=${CACHE_DIR}/externals}"
diff --git a/tests/CI/installAsterisk.sh b/tests/CI/installAsterisk.sh
index 00866d11ca8550b9d922a23b7e41673728439ad6..da48bc2a6c5cc2a8d69bb8fb3ac19ac7b42015b6 100755
--- a/tests/CI/installAsterisk.sh
+++ b/tests/CI/installAsterisk.sh
@@ -10,8 +10,17 @@ MAKE=`which make`
 if [ x"$DESTDIR" != x ] ; then
 	mkdir -p "$DESTDIR"
 fi
+
+if [[ "$BRANCH_NAME" =~ devel(opment)?/([0-9]+)/.+ ]] ; then
+	export MAINLINE_BRANCH="${BASH_REMATCH[2]}"
+fi
+_version=$(./build_tools/make_version .)
+
 destdir=${DESTDIR:+DESTDIR=$DESTDIR}
 
+declare -p _version
+declare -p destdir
+
 [ $UNINSTALL -gt 0 ] && ${MAKE} ${destdir} uninstall
 [ $UNINSTALL_ALL -gt 0 ] && ${MAKE} ${destdir} uninstall-all